
// Todo:
// - parameterize
// - shave corner off of vertical brace
// - switch to whowhatsis' teardrop library
// - invert teardrop holes for better printing and more servicable bolt locations
// - reduce length of sleeve bearing section

// Configuration:
$x_bar_spacing = 0;
$x_bar_diameter = 8;
$y_bar_diameter = 8;
$idler_slot_width = 0;

$x_bar_radius = $x_bar_diameter / 2;
$y_bar_radius = $y_bar_diameter / 2;
$x_block_width = $x_bar_spacing + $x_bar_diameter + 8;

module y_rod(r, h)
{
	union()
	{
		translate([0, -2, 0]) rotate([0,90,0]) rotate([0, 0, 22.5]) cylinder(r=r,h=h, $fn=8);
		translate([0,  2, 0]) rotate([0,90,0]) rotate([0, 0, 22.5]) cylinder(r=r,h=h, $fn=8);
		translate([0, -2, r]) rotate([0,90,0]) cube(size = [2*r, 4, h]);
	}
}

module x_end_idler()
{
	translate([0,42,-11])
	difference(){
	translate(v = [-35,-65,-25]) cube([70,70,63]);

	//nut traps and set screws to hold x-rods
	//for ( y = [-27, -57]) {
	for ( y = [-57]) {
		for ( x = [-25, 25]) {
			translate(v = [x, y, -5]) cylinder(h = 7, r=3.5, $fn=6, center=true);
			translate(v = [x, y, 18]) cylinder(h = 50, r=2.2, $fn=12, center=true);
			//translate(v = [x, y, 41]) cylinder(h = 30, r=4, $fn=12, center=true);
			//translate(v = [x, y, 25]) cylinder(h = 2, r1=2.2, r2=4, $fn=12, center=true);
		}
	}

	// Access for belt clamp nuts and idler pulley nut
	translate(v = [-10, -12, 0]) cube(size = [75, 38, 65], center = true);
	translate(v = [0, -12, -35]) cube(size = [75, 38, 65], center = true);
	
	for ( y = [-25, -5]) {
		translate(v = [0, y, 30]) cube(size = [75, 5, 5], center=true);
	}

	//belt clamp bolts
	for ( y = [-25, -5]) {
		for ( x = [-25, 25]) {
			translate(v = [x, y, -20]) cylinder(h = 200, r=2.2, $fn=9, center=true);
		}
	}
	
	//idler pulley bolt
	translate([30,-15,11]) rotate([0,90,0]) rotate([0, 0, 22.5]) cylinder(r=4,h=15, $fn=8, center = true);
	

	//holes for x-rods
	translate(v = [-25, -18, -12]) rotate(a=[90,0,0]) {
		cylinder(h = 120, r=4.5, $fn=15, center=true);
		translate(v = [0, -2.8, 0]) rotate(a=[0,0,45]) cube(size = [5,5,120], center = true);
	}

	//holes for x-rods
	translate(v = [25, -18, -12]) rotate(a=[90,0,0]) {
		cylinder(h = 120, r=4.5, $fn=15, center=true);
		translate(v = [0, -2.8, 0]) rotate(a=[0,0,45]) cube(size = [5,5,120], center = true);
	}

	//hole for y-rod
	translate([-36,-42,11]) y_rod(r=4,h=72);
	translate([-36,-42,11]) y_rod(r=5,h=30);
	translate([  6,-42,11]) y_rod(r=5,h=30);

	// Remove extra material
	//translate(v = [0, -4, 0]) cube(size = [75, 30, 65], center = true);
	//translate(v = [0, -70, 0]) cube(size = [28, 30, 80], center = true);
	translate(v = [-40,-150,0]) rotate([-22.5, 0, 0]) cube([80,80,80]);


	} // difference()


	//translate([0,42,-11])
	//translate(v = [-40,-147,1]) rotate([-22.5, 0, 0]) cube([80,80,80]);


	//translate ([-100, 0, 0])
	//rotate([90, 0, 0])
	//union()
	//{
	//translate([-30, -17.5, -35])
	//import_stl("/home/mccoyn/reprap/reprap-objects-1.1.1/Darwin/RP-parts-and-jigs/X-idler-bracket.stl");
	//translate([-15, -17.5, -10])
	//import_stl("/home/mccoyn/reprap/reprap-objects-1.1.1/Darwin/RP-parts-and-jigs/X-constraint-bracket.stl");
	//}
}

translate([0, 0, 27])
rotate([180, 0, 0])
x_end_idler();

